diff -urN -x compile -x LINT vendor/freebsd/src/sys/netinet/test.c user/rwatson/tcp/src/sys/netinet/test.c
--- vendor/freebsd/src/sys/netinet/test.c	1970-01-01 01:00:00.000000000 +0100
+++ user/rwatson/tcp/src/sys/netinet/test.c	2010-06-11 21:01:04.915021589 +0100
@@ -0,0 +1,252 @@
+/*-
+ * Copyright (c) 2010 David Malone <dwmalone@FreeBSD.org>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD$");
+
+#include <sys/types.h>
+
+#include <netinet/in_rss.h>
+#include <netinet/toeplitz.h>
+
+#ifdef _KERNEL
+#include <sys/systm.h>
+#else
+#include <err.h>
+#include <stdio.h>
+#endif
+
+#ifndef _KERNEL
+static uint8_t	tkey8[RSS_KEYSIZE] = {
+	0x6d, 0x5a, 0x56, 0xda, 0x25, 0x5b, 0x0e, 0xc2,
+	0x41, 0x67, 0x25, 0x3d, 0x43, 0xa3, 0x8f, 0xb0,
+	0xd0, 0xca, 0x2b, 0xcb, 0xae, 0x7b, 0x30, 0xb4,
+	0x77, 0xcb, 0x2d, 0xa3, 0x80, 0x30, 0xf2, 0x0c,
+	0x6a, 0x42, 0xb7, 0x3b, 0xbe, 0xac, 0x01, 0xfa
+};
+
+static uint8_t	zkey8[RSS_KEYSIZE];
+
+static uint8_t	okey8[RSS_KEYSIZE] = {
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+	0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
+};
+
+/* Default Chelsio hardware key. */
+static uint8_t	ckey8[] = {
+	0x6d, 0x5a, 0x56, 0xda,
+	0x25, 0x5b, 0x0e, 0xc2,
+	0x41, 0x67, 0x25, 0x3d,
+	0x43, 0xa3, 0x8f, 0xb0,
+};
+
+#define	min(x, y)	((x) < (y) ? (x) : (y))
+#endif
+
+uint32_t
+toeplitz_hash(u_int keylen, const uint8_t *key, u_int netperf_datalen,
+    const uint8_t *netperf_data)
+{
+	uint32_t hash = 0, v;
+	u_int i, b;
+
+	/* XXXRW: Perhaps an assertion about key length vs. netperf_data length? */
+
+	v = (key[0]<<24) + (key[1]<<16) + (key[2] <<8) + key[3];
+	for (i = 0; i < netperf_datalen; i++) {
+		for (b = 0; b < 8; b++) {
+			if (netperf_data[i] & (1<<(7-b)))
+				hash ^= v;
+			v <<= 1;
+			if ((i + 4) < RSS_KEYSIZE &&
+			    (key[i+4] & (1<<(7-b))))
+				v |= 1;
+		}
+	}
+	return (hash);
+}
+
+/*
+ * Remaning code in this file consists of test vectors and a userspace main()
+ * function to validate the hash implementation.
+ */
+#ifndef _KERNEL
+static u_int hash1 = 0x323e8fc2;
+
+static uint8_t netperf_data2[] = { 199, 92, 111, 2, 65, 69, 140, 83 };
+static u_int hash2 = 0xd718262a;
+
+static uint8_t netperf_data3[] = { 24, 19, 198, 95, 12, 22, 207, 184 };
+static u_int hash3 = 0xd2d0a5de;
+
+static uint8_t netperf_data4[] = { 38, 27, 205, 30, 209, 142, 163, 6 };
+static u_int hash4 = 0x82989176;
+
+static uint8_t netperf_data5[] = { 153, 39, 163, 191, 202, 188, 127, 2 };
+static u_int hash5 = 0x5d1809c5;
+
+#define PORT(n) (((n)>>8)&0xff), ((n)&0xff)
+
+static uint8_t netperf_data1[] = { 66, 9, 149, 187, 161, 142, 100, 80 };
+static uint8_t netperf_data1p[] = {
+	66, 9, 149, 187, 161, 142, 100, 80, PORT(2794), PORT(1766)
+};
+
+static u_int hash1p = 0x51ccc178;
+
+static uint8_t netperf_data2p[] = {
+	199, 92, 111, 2, 65, 69, 140, 83, PORT(14230), PORT(4739)
+};
+static u_int hash2p = 0xc626b0ea;
+
+static uint8_t netperf_data3p[] = {
+	24, 19, 198, 95, 12, 22, 207, 184, PORT(12898), PORT(38024)
+};
+static u_int hash3p = 0x5c2b394a;
+
+static uint8_t netperf_data4p[] = {
+	38, 27, 205, 30, 209, 142, 163, 6, PORT(48228), PORT(2217)
+};
+static u_int hash4p = 0xafc7327f;
+
+static uint8_t netperf_data5p[] = {
+	153, 39, 163, 191, 202, 188, 127, 2, PORT(44251), PORT(1303)
+};
+static u_int hash5p = 0x10e828a2;
+
+#define IPv6(a1,a2,a3,a4,a5,a6,a7,a8)					\
+	(((0x##a1)>>8)&0xff), ((0x##a1)&0xff),				\
+	(((0x##a2)>>8)&0xff), ((0x##a2)&0xff),				\
+	(((0x##a3)>>8)&0xff), ((0x##a3)&0xff),				\
+	(((0x##a4)>>8)&0xff), ((0x##a4)&0xff),				\
+ 	(((0x##a5)>>8)&0xff), ((0x##a5)&0xff),				\
+	(((0x##a6)>>8)&0xff), ((0x##a6)&0xff),				\
+	(((0x##a7)>>8)&0xff), ((0x##a7)&0xff),				\
+	(((0x##a8)>>8)&0xff), ((0x##a8)&0xff)
+
+static uint8_t netperf_data1v6[] = {
+	IPv6(3ffe, 2501, 200, 1fff, 0, 0, 0, 7),
+	IPv6(3ffe, 2501, 200, 3, 0, 0, 0, 1)
+};
+static u_int hash1v6 = 0x2cc18cd5;
+
+static uint8_t netperf_data2v6[] = {
+	IPv6(3ffe, 501, 8, 0, 260, 97ff, fe40, efab),
+	IPv6(ff02, 0, 0, 0, 0, 0, 0, 1)
+};
+static u_int hash2v6 = 0x0f0c461c;
+
+static uint8_t netperf_data3v6[] = {
+	IPv6(3ffe, 1900, 4545, 3, 200, f8ff, fe21, 67cf),
+	IPv6(fe80, 0, 0, 0, 200, f8ff, fe21, 67cf)
+};
+static u_int hash3v6 = 0x4b61e985;
+
+static uint8_t netperf_data1v6p[] = {
+	IPv6(3ffe, 2501, 200, 1fff, 0, 0, 0, 7),
+	IPv6(3ffe, 2501, 200, 3, 0, 0, 0, 1),
+	PORT(2794), PORT(1766)
+};
+static u_int hash1v6p = 0x40207d3d;
+
+static uint8_t netperf_data2v6p[] = {
+	IPv6(3ffe, 501, 8, 0, 260, 97ff, fe40, efab),
+	IPv6(ff02, 0, 0, 0, 0, 0, 0, 1),
+	PORT(14230), PORT(4739)
+};
+static u_int hash2v6p = 0xdde51bbf;
+
+static uint8_t netperf_data3v6p[] = {
+	IPv6(3ffe, 1900, 4545, 3, 200, f8ff, fe21, 67cf),
+	IPv6(fe80, 0, 0, 0, 200, f8ff, fe21, 67cf),
+	PORT(44251), PORT(38024)
+};
+static u_int hash3v6p = 0x02d1feef;
+
+/*
+ * Netperf cluster.
+ */
+static uint8_t netperf_data[] = {
+	192, 168, 100, 102, 192, 168, 100, 101, PORT(22), PORT(42658)
+};
+
+#define	TEST(tag) do {							\
+	unsigned int v1, v2;						\
+	v1 = hash ## tag;						\
+	v2 = toeplitz_hash(sizeof(tkey8), tkey8, sizeof(netperf_data ## tag),	\
+	    netperf_data ## tag);						\
+	if (v1 != v2)							\
+		errx(-1, "FAIL vector failed:%08x %08x %08x "		\
+		    "%zd\n", v1, v2, v1 ^ v2, sizeof(netperf_data ## tag));	\
+} while (0)
+		
+int
+main(int argc, char *argv[])
+{
+	unsigned int v;
+	TEST(1);
+	TEST(2);
+	TEST(3);
+	TEST(4);
+	TEST(5);
+
+	TEST(1p);
+	TEST(2p);
+	TEST(3p);
+	TEST(4p);
+	TEST(5p);
+
+	TEST(1v6);
+	TEST(2v6);
+	TEST(3v6);
+
+	TEST(1v6p);
+	TEST(2v6p);
+	TEST(3v6p);
+
+	printf("PASS\n");
+
+	printf("Sample hashes:\n");
+
+	printf("Test key: %08x\n",
+	    toeplitz_hash(sizeof(tkey8), tkey8, sizeof(netperf_data1), netperf_data1));
+	
+	printf("All zeroes: %08x\n",
+	    toeplitz_hash(sizeof(zkey8), zkey8, sizeof(netperf_data1), netperf_data1));
+
+	printf("All ones: %08x\n",
+	    toeplitz_hash(sizeof(okey8), okey8, sizeof(netperf_data1), netperf_data1));
+
+	printf("Chelsio key: %08x\n",
+	    toeplitz_hash(sizeof(ckey8), ckey8, sizeof(netperf_data),
+	    netperf_data));
+
+	return (0);
+}
+#endif
Files vendor/freebsd/src/sys/netinet/toeplitz and user/rwatson/tcp/src/sys/netinet/toeplitz differ
diff -urN -x compile -x LINT vendor/freebsd/src/sys/netinet/toeplitz.c user/rwatson/tcp/src/sys/netinet/toeplitz.c
--- vendor/freebsd/src/sys/netinet/toeplitz.c	1970-01-01 01:00:00.000000000 +0100
+++ user/rwatson/tcp/src/sys/netinet/toeplitz.c	2010-06-07 13:14:58.623200617 +0100
@@ -0,0 +1,211 @@
+/*-
+ * Copyright (c) 2010 David Malone <dwmalone@FreeBSD.org>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD$");
+
+#include <sys/types.h>
+
+#include <netinet/in_rss.h>
+#include <netinet/toeplitz.h>
+
+#ifdef _KERNEL
+#include <sys/systm.h>
+#else
+#include <err.h>
+#include <stdio.h>
+#endif
+
+#ifndef _KERNEL
+static uint8_t	tkey8[RSS_KEYSIZE] = {
+	0x6d, 0x5a, 0x56, 0xda, 0x25, 0x5b, 0x0e, 0xc2,
+	0x41, 0x67, 0x25, 0x3d, 0x43, 0xa3, 0x8f, 0xb0,
+	0xd0, 0xca, 0x2b, 0xcb, 0xae, 0x7b, 0x30, 0xb4,
+	0x77, 0xcb, 0x2d, 0xa3, 0x80, 0x30, 0xf2, 0x0c,
+	0x6a, 0x42, 0xb7, 0x3b, 0xbe, 0xac, 0x01, 0xfa
+};
+
+#define	min(x, y)	((x) < (y) ? (x) : (y))
+#endif
+
+uint32_t
+toeplitz_hash(u_int keylen, const uint8_t *key, u_int datalen,
+    const uint8_t *data)
+{
+	uint32_t hash = 0, v;
+	u_int i, b;
+
+	/* XXXRW: Perhaps an assertion about key length vs. data length? */
+
+	v = (key[0]<<24) + (key[1]<<16) + (key[2] <<8) + key[3];
+	for (i = 0; i < datalen; i++) {
+		for (b = 0; b < 8; b++) {
+			if (data[i] & (1<<(7-b)))
+				hash ^= v;
+			v <<= 1;
+			if ((i + 4) < RSS_KEYSIZE &&
+			    (key[i+4] & (1<<(7-b))))
+				v |= 1;
+		}
+	}
+	return (hash);
+}
+
+/*
+ * Remaning code in this file consists of test vectors and a userspace main()
+ * function to validate the hash implementation.
+ */
+#ifndef _KERNEL
+static u_int hash1 = 0x323e8fc2;
+
+static uint8_t data2[] = { 199, 92, 111, 2, 65, 69, 140, 83 };
+static u_int hash2 = 0xd718262a;
+
+static uint8_t data3[] = { 24, 19, 198, 95, 12, 22, 207, 184 };
+static u_int hash3 = 0xd2d0a5de;
+
+static uint8_t data4[] = { 38, 27, 205, 30, 209, 142, 163, 6 };
+static u_int hash4 = 0x82989176;
+
+static uint8_t data5[] = { 153, 39, 163, 191, 202, 188, 127, 2 };
+static u_int hash5 = 0x5d1809c5;
+
+#define PORT(n) (((n)>>8)&0xff), ((n)&0xff)
+
+static uint8_t data1[] = { 66, 9, 149, 187, 161, 142, 100, 80 };
+static uint8_t data1p[] = {
+	66, 9, 149, 187, 161, 142, 100, 80, PORT(2794), PORT(1766)
+};
+
+static u_int hash1p = 0x51ccc178;
+
+static uint8_t data2p[] = {
+	199, 92, 111, 2, 65, 69, 140, 83, PORT(14230), PORT(4739)
+};
+static u_int hash2p = 0xc626b0ea;
+
+static uint8_t data3p[] = {
+	24, 19, 198, 95, 12, 22, 207, 184, PORT(12898), PORT(38024)
+};
+static u_int hash3p = 0x5c2b394a;
+
+static uint8_t data4p[] = {
+	38, 27, 205, 30, 209, 142, 163, 6, PORT(48228), PORT(2217)
+};
+static u_int hash4p = 0xafc7327f;
+
+static uint8_t data5p[] = {
+	153, 39, 163, 191, 202, 188, 127, 2, PORT(44251), PORT(1303)
+};
+static u_int hash5p = 0x10e828a2;
+
+#define IPv6(a1,a2,a3,a4,a5,a6,a7,a8)					\
+	(((0x##a1)>>8)&0xff), ((0x##a1)&0xff),				\
+	(((0x##a2)>>8)&0xff), ((0x##a2)&0xff),				\
+	(((0x##a3)>>8)&0xff), ((0x##a3)&0xff),				\
+	(((0x##a4)>>8)&0xff), ((0x##a4)&0xff),				\
+ 	(((0x##a5)>>8)&0xff), ((0x##a5)&0xff),				\
+	(((0x##a6)>>8)&0xff), ((0x##a6)&0xff),				\
+	(((0x##a7)>>8)&0xff), ((0x##a7)&0xff),				\
+	(((0x##a8)>>8)&0xff), ((0x##a8)&0xff)
+
+static uint8_t data1v6[] = {
+	IPv6(3ffe, 2501, 200, 1fff, 0, 0, 0, 7),
+	IPv6(3ffe, 2501, 200, 3, 0, 0, 0, 1)
+};
+static u_int hash1v6 = 0x2cc18cd5;
+
+static uint8_t data2v6[] = {
+	IPv6(3ffe, 501, 8, 0, 260, 97ff, fe40, efab),
+	IPv6(ff02, 0, 0, 0, 0, 0, 0, 1)
+};
+static u_int hash2v6 = 0x0f0c461c;
+
+static uint8_t data3v6[] = {
+	IPv6(3ffe, 1900, 4545, 3, 200, f8ff, fe21, 67cf),
+	IPv6(fe80, 0, 0, 0, 200, f8ff, fe21, 67cf)
+};
+static u_int hash3v6 = 0x4b61e985;
+
+static uint8_t data1v6p[] = {
+	IPv6(3ffe, 2501, 200, 1fff, 0, 0, 0, 7),
+	IPv6(3ffe, 2501, 200, 3, 0, 0, 0, 1),
+	PORT(2794), PORT(1766)
+};
+static u_int hash1v6p = 0x40207d3d;
+
+static uint8_t data2v6p[] = {
+	IPv6(3ffe, 501, 8, 0, 260, 97ff, fe40, efab),
+	IPv6(ff02, 0, 0, 0, 0, 0, 0, 1),
+	PORT(14230), PORT(4739)
+};
+static u_int hash2v6p = 0xdde51bbf;
+
+static uint8_t data3v6p[] = {
+	IPv6(3ffe, 1900, 4545, 3, 200, f8ff, fe21, 67cf),
+	IPv6(fe80, 0, 0, 0, 200, f8ff, fe21, 67cf),
+	PORT(44251), PORT(38024)
+};
+static u_int hash3v6p = 0x02d1feef;
+
+#define	TEST(tag) do {							\
+	unsigned int v1, v2;						\
+	v1 = hash ## tag;						\
+	v2 = toeplitz_hash(sizeof(tkey8), tkey8, sizeof(data ## tag),	\
+	    data ## tag);						\
+	if (v1 != v2)							\
+		errx(-1, "FAIL vector failed:%08x %08x %08x "		\
+		    "%zd\n", v1, v2, v1 ^ v2, sizeof(data ## tag));	\
+} while (0)
+		
+int
+main(int argc, char *argv[])
+{
+	TEST(1);
+	TEST(2);
+	TEST(3);
+	TEST(4);
+	TEST(5);
+
+	TEST(1p);
+	TEST(2p);
+	TEST(3p);
+	TEST(4p);
+	TEST(5p);
+
+	TEST(1v6);
+	TEST(2v6);
+	TEST(3v6);
+
+	TEST(1v6p);
+	TEST(2v6p);
+	TEST(3v6p);
+
+	printf("PASS\n");
+
+	return (0);
+}
+#endif
diff -urN -x compile -x LINT vendor/freebsd/src/sys/netinet/toeplitz.h user/rwatson/tcp/src/sys/netinet/toeplitz.h
--- vendor/freebsd/src/sys/netinet/toeplitz.h	1970-01-01 01:00:00.000000000 +0100
+++ user/rwatson/tcp/src/sys/netinet/toeplitz.h	2010-06-07 13:14:58.623200617 +0100
@@ -0,0 +1,38 @@
+/*-
+ * Copyright (c) 2010 David Malone <dwmalone@FreeBSD.org>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef _NETINET_TOEPLITZ_H_
+#define	_NETINET_TOEPLITZ_H_
+
+/*
+ * Toeplitz (RSS) hash algorithm; possibly we should cache intermediate
+ * results between runs, in which case we'll need explicit init/destroy and
+ * state management.
+ */
+uint32_t	toeplitz_hash(u_int keylen, const uint8_t *key,
+		    u_int datalen, const uint8_t *data);
+
+#endif /* !_NETINET_TOEPLITZ_H_ */
diff -urN -x compile -x LINT vendor/freebsd/src/sys/netinet/udp_usrreq.c user/rwatson/tcp/src/sys/netinet/udp_usrreq.c
--- vendor/freebsd/src/sys/netinet/udp_usrreq.c	2011-02-01 09:38:55.724042981 +0000
+++ user/rwatson/tcp/src/sys/netinet/udp_usrreq.c	2011-02-01 08:30:21.553409283 +0000
@@ -139,6 +139,7 @@
 #endif
 
 VNET_DEFINE(struct udpstat, udpstat);		/* from udp_var.h */
+
 SYSCTL_VNET_STRUCT(_net_inet_udp, UDPCTL_STATS, stats, CTLFLAG_RW,
     &VNET_NAME(udpstat), udpstat,
     "UDP statistics (struct udpstat, netinet/udp_var.h)");
@@ -178,7 +179,8 @@
 {
 
 	in_pcbinfo_init(&V_udbinfo, "udp", &V_udb, UDBHASHSIZE, UDBHASHSIZE,
-	    "udp_inpcb", udp_inpcb_init, NULL, UMA_ZONE_NOFREE);
+	    "udp_inpcb", udp_inpcb_init, NULL, UMA_ZONE_NOFREE,
+	    IPI_HASHFIELDS_2TUPLE);
 	V_udpcb_zone = uma_zcreate("udpcb", sizeof(struct udpcb),
 	    NULL, NULL, NULL, NULL, UMA_ALIGN_PTR, UMA_ZONE_NOFREE);
 	uma_zone_set_max(V_udpcb_zone, maxsockets);
@@ -254,7 +256,7 @@
 #endif
 #endif
 
-	INP_RLOCK_ASSERT(inp);
+	INP_LOCK_ASSERT(inp);
 
 #ifdef IPSEC
 	/* Check AH/ESP integrity. */
@@ -448,12 +450,12 @@
 	}
 #endif
 
-	INP_INFO_RLOCK(&V_udbinfo);
 	if (IN_MULTICAST(ntohl(ip->ip_dst.s_addr)) ||
 	    in_broadcast(ip->ip_dst, ifp)) {
 		struct inpcb *last;
 		struct ip_moptions *imo;
 
+		INP_INFO_RLOCK(&V_udbinfo);
 		last = NULL;
 		LIST_FOREACH(inp, &V_udb, inp_list) {
 			if (inp->inp_lport != uh->uh_dport)
@@ -567,8 +569,9 @@
 	/*
 	 * Locate pcb for datagram.
 	 */
-	inp = in_pcblookup_hash(&V_udbinfo, ip->ip_src, uh->uh_sport,
-	    ip->ip_dst, uh->uh_dport, 1, ifp);
+	inp = in_pcblookup_mbuf(&V_udbinfo, ip->ip_src, uh->uh_sport,
+	    ip->ip_dst, uh->uh_dport, INPLOOKUP_WILDCARD | INPLOOKUP_RLOCKPCB,
+	    ifp, m);
 	if (inp == NULL) {
 		if (udp_log_in_vain) {
 			char buf[4*sizeof "123"];
@@ -582,27 +585,26 @@
 		UDPSTAT_INC(udps_noport);
 		if (m->m_flags & (M_BCAST | M_MCAST)) {
 			UDPSTAT_INC(udps_noportbcast);
-			goto badheadlocked;
+			goto badunlocked;
 		}
 		if (V_udp_blackhole)
-			goto badheadlocked;
+			goto badunlocked;
 		if (badport_bandlim(BANDLIM_ICMP_UNREACH) < 0)
-			goto badheadlocked;
+			goto badunlocked;
 		*ip = save_ip;
 		ip->ip_len += iphlen;
 		icmp_error(m, ICMP_UNREACH, ICMP_UNREACH_PORT, 0, 0);
-		INP_INFO_RUNLOCK(&V_udbinfo);
 		return;
 	}
 
 	/*
 	 * Check the minimum TTL for socket.
 	 */
-	INP_RLOCK(inp);
-	INP_INFO_RUNLOCK(&V_udbinfo);
+	INP_RLOCK_ASSERT(inp);
 	if (inp->inp_ip_minttl && inp->inp_ip_minttl > ip->ip_ttl) {
 		INP_RUNLOCK(inp);
-		goto badunlocked;
+		m_freem(m);
+		return;
 	}
 	up = intoudpcb(inp);
 	if (up->u_tun_func == NULL) {
@@ -677,17 +679,15 @@
 		return;
 	if (ip != NULL) {
 		uh = (struct udphdr *)((caddr_t)ip + (ip->ip_hl << 2));
-		INP_INFO_RLOCK(&V_udbinfo);
-		inp = in_pcblookup_hash(&V_udbinfo, faddr, uh->uh_dport,
-		    ip->ip_src, uh->uh_sport, 0, NULL);
+		inp = in_pcblookup(&V_udbinfo, faddr, uh->uh_dport,
+		    ip->ip_src, uh->uh_sport, INPLOOKUP_WLOCKPCB, NULL);
 		if (inp != NULL) {
-			INP_RLOCK(inp);
+			INP_WLOCK_ASSERT(inp);
 			if (inp->inp_socket != NULL) {
 				udp_notify(inp, inetctlerrmap[cmd]);
 			}
-			INP_RUNLOCK(inp);
+			INP_WUNLOCK(inp);
 		}
-		INP_INFO_RUNLOCK(&V_udbinfo);
 	} else
 		in_pcbnotifyall(&V_udbinfo, faddr, inetctlerrmap[cmd],
 		    udp_notify);
@@ -776,9 +776,9 @@
 	INP_INFO_WLOCK(&V_udbinfo);
 	for (i = 0; i < n; i++) {
 		inp = inp_list[i];
-		INP_WLOCK(inp);
-		if (!in_pcbrele(inp))
-			INP_WUNLOCK(inp);
+		INP_RLOCK(inp);
+		if (!in_pcbrele_rlocked(inp))
+			INP_RUNLOCK(inp);
 	}
 	INP_INFO_WUNLOCK(&V_udbinfo);
 
@@ -817,12 +817,11 @@
 	error = SYSCTL_IN(req, addrs, sizeof(addrs));
 	if (error)
 		return (error);
-	INP_INFO_RLOCK(&V_udbinfo);
-	inp = in_pcblookup_hash(&V_udbinfo, addrs[1].sin_addr, addrs[1].sin_port,
-				addrs[0].sin_addr, addrs[0].sin_port, 1, NULL);
+	inp = in_pcblookup(&V_udbinfo, addrs[1].sin_addr, addrs[1].sin_port,
+	    addrs[0].sin_addr, addrs[0].sin_port,
+	    INPLOOKUP_WILDCARD | INPLOOKUP_RLOCKPCB, NULL);
 	if (inp != NULL) {
-		INP_RLOCK(inp);
-		INP_INFO_RUNLOCK(&V_udbinfo);
+		INP_RLOCK_ASSERT(inp);
 		if (inp->inp_socket == NULL)
 			error = ENOENT;
 		if (error == 0)
@@ -830,10 +829,8 @@
 		if (error == 0)
 			cru2x(inp->inp_cred, &xuc);
 		INP_RUNLOCK(inp);
-	} else {
-		INP_INFO_RUNLOCK(&V_udbinfo);
+	} else
 		error = ENOENT;
-	}
 	if (error == 0)
 		error = SYSCTL_OUT(req, &xuc, sizeof(struct xucred));
 	return (error);
@@ -1028,14 +1025,16 @@
 	 * conservative locks than required the second time around, so later
 	 * assertions have to accept that.  Further analysis of the number of
 	 * misses under contention is required.
+	 *
+	 * XXXRW: Check that hash locking update here is correct.
 	 */
 	sin = (struct sockaddr_in *)addr;
 	INP_RLOCK(inp);
 	if (sin != NULL &&
 	    (inp->inp_laddr.s_addr == INADDR_ANY && inp->inp_lport == 0)) {
 		INP_RUNLOCK(inp);
-		INP_INFO_WLOCK(&V_udbinfo);
 		INP_WLOCK(inp);
+		INP_HASH_WLOCK(&V_udbinfo);
 		unlock_udbinfo = 2;
 	} else if ((sin != NULL && (
 	    (sin->sin_addr.s_addr == INADDR_ANY) ||
@@ -1043,11 +1042,7 @@
 	    (inp->inp_laddr.s_addr == INADDR_ANY) ||
 	    (inp->inp_lport == 0))) ||
 	    (src.sin_family == AF_INET)) {
-		if (!INP_INFO_TRY_RLOCK(&V_udbinfo)) {
-			INP_RUNLOCK(inp);
-			INP_INFO_RLOCK(&V_udbinfo);
-			INP_RLOCK(inp);
-		}
+		INP_HASH_RLOCK(&V_udbinfo);
 		unlock_udbinfo = 1;
 	} else
 		unlock_udbinfo = 0;
@@ -1060,7 +1055,7 @@
 	laddr = inp->inp_laddr;
 	lport = inp->inp_lport;
 	if (src.sin_family == AF_INET) {
-		INP_INFO_LOCK_ASSERT(&V_udbinfo);
+		INP_HASH_LOCK_ASSERT(&V_udbinfo);
 		if ((lport == 0) ||
 		    (laddr.s_addr == INADDR_ANY &&
 		     src.sin_addr.s_addr == INADDR_ANY)) {
@@ -1111,7 +1106,7 @@
 		    inp->inp_lport == 0 ||
 		    sin->sin_addr.s_addr == INADDR_ANY ||
 		    sin->sin_addr.s_addr == INADDR_BROADCAST) {
-			INP_INFO_LOCK_ASSERT(&V_udbinfo);
+			INP_HASH_LOCK_ASSERT(&V_udbinfo);
 			error = in_pcbconnect_setup(inp, addr, &laddr.s_addr,
 			    &lport, &faddr.s_addr, &fport, NULL,
 			    td->td_ucred);
@@ -1125,8 +1120,8 @@
 			/* Commit the local port if newly assigned. */
 			if (inp->inp_laddr.s_addr == INADDR_ANY &&
 			    inp->inp_lport == 0) {
-				INP_INFO_WLOCK_ASSERT(&V_udbinfo);
 				INP_WLOCK_ASSERT(inp);
+				INP_HASH_WLOCK_ASSERT(&V_udbinfo);
 				/*
 				 * Remember addr if jailed, to prevent
 				 * rebinding.
@@ -1222,9 +1217,9 @@
 	UDPSTAT_INC(udps_opackets);
 
 	if (unlock_udbinfo == 2)
-		INP_INFO_WUNLOCK(&V_udbinfo);
+		INP_HASH_WUNLOCK(&V_udbinfo);
 	else if (unlock_udbinfo == 1)
-		INP_INFO_RUNLOCK(&V_udbinfo);
+		INP_HASH_RUNLOCK(&V_udbinfo);
 	error = ip_output(m, inp->inp_options, NULL, ipflags,
 	    inp->inp_moptions, inp);
 	if (unlock_udbinfo == 2)
@@ -1235,11 +1230,11 @@
 
 release:
 	if (unlock_udbinfo == 2) {
+		INP_HASH_WUNLOCK(&V_udbinfo);
 		INP_WUNLOCK(inp);
-		INP_INFO_WUNLOCK(&V_udbinfo);
 	} else if (unlock_udbinfo == 1) {
+		INP_HASH_RUNLOCK(&V_udbinfo);
 		INP_RUNLOCK(inp);
-		INP_INFO_RUNLOCK(&V_udbinfo);
 	} else
 		INP_RUNLOCK(inp);
 	m_freem(m);
@@ -1390,15 +1385,15 @@
 
 	inp = sotoinpcb(so);
 	KASSERT(inp != NULL, ("udp_abort: inp == NULL"));
-	INP_INFO_WLOCK(&V_udbinfo);
 	INP_WLOCK(inp);
 	if (inp->inp_faddr.s_addr != INADDR_ANY) {
+		INP_HASH_WLOCK(&V_udbinfo);
 		in_pcbdisconnect(inp);
 		inp->inp_laddr.s_addr = INADDR_ANY;
+		INP_HASH_WUNLOCK(&V_udbinfo);
 		soisdisconnected(so);
 	}
 	INP_WUNLOCK(inp);
-	INP_INFO_WUNLOCK(&V_udbinfo);
 }
 
 static int
@@ -1465,11 +1460,11 @@
 
 	inp = sotoinpcb(so);
 	KASSERT(inp != NULL, ("udp_bind: inp == NULL"));
-	INP_INFO_WLOCK(&V_udbinfo);
 	INP_WLOCK(inp);
+	INP_HASH_WLOCK(&V_udbinfo);
 	error = in_pcbbind(inp, nam, td->td_ucred);
+	INP_HASH_WUNLOCK(&V_udbinfo);
 	INP_WUNLOCK(inp);
-	INP_INFO_WUNLOCK(&V_udbinfo);
 	return (error);
 }
 
@@ -1480,15 +1475,15 @@
 
 	inp = sotoinpcb(so);
 	KASSERT(inp != NULL, ("udp_close: inp == NULL"));
-	INP_INFO_WLOCK(&V_udbinfo);
 	INP_WLOCK(inp);
 	if (inp->inp_faddr.s_addr != INADDR_ANY) {
+		INP_HASH_WLOCK(&V_udbinfo);
 		in_pcbdisconnect(inp);
 		inp->inp_laddr.s_addr = INADDR_ANY;
+		INP_HASH_WUNLOCK(&V_udbinfo);
 		soisdisconnected(so);
 	}
 	INP_WUNLOCK(inp);
-	INP_INFO_WUNLOCK(&V_udbinfo);
 }
 
 static int
@@ -1500,25 +1495,23 @@
 
 	inp = sotoinpcb(so);
 	KASSERT(inp != NULL, ("udp_connect: inp == NULL"));
-	INP_INFO_WLOCK(&V_udbinfo);
 	INP_WLOCK(inp);
 	if (inp->inp_faddr.s_addr != INADDR_ANY) {
 		INP_WUNLOCK(inp);
-		INP_INFO_WUNLOCK(&V_udbinfo);
 		return (EISCONN);
 	}
 	sin = (struct sockaddr_in *)nam;
 	error = prison_remote_ip4(td->td_ucred, &sin->sin_addr);
 	if (error != 0) {
 		INP_WUNLOCK(inp);
-		INP_INFO_WUNLOCK(&V_udbinfo);
 		return (error);
 	}
+	INP_HASH_WLOCK(&V_udbinfo);
 	error = in_pcbconnect(inp, nam, td->td_ucred);
+	INP_HASH_WUNLOCK(&V_udbinfo);
 	if (error == 0)
 		soisconnected(so);
 	INP_WUNLOCK(inp);
-	INP_INFO_WUNLOCK(&V_udbinfo);
 	return (error);
 }
 
@@ -1550,21 +1543,19 @@
 
 	inp = sotoinpcb(so);
 	KASSERT(inp != NULL, ("udp_disconnect: inp == NULL"));
-	INP_INFO_WLOCK(&V_udbinfo);
 	INP_WLOCK(inp);
 	if (inp->inp_faddr.s_addr == INADDR_ANY) {
 		INP_WUNLOCK(inp);
-		INP_INFO_WUNLOCK(&V_udbinfo);
 		return (ENOTCONN);
 	}
-
+	INP_HASH_WLOCK(&V_udbinfo);
 	in_pcbdisconnect(inp);
 	inp->inp_laddr.s_addr = INADDR_ANY;
+	INP_HASH_WUNLOCK(&V_udbinfo);
 	SOCK_LOCK(so);
 	so->so_state &= ~SS_ISCONNECTED;		/* XXX */
 	SOCK_UNLOCK(so);
 	INP_WUNLOCK(inp);
-	INP_INFO_WUNLOCK(&V_udbinfo);
 	return (0);
 }
 
